﻿using Infragistics.Win.UltraWinTabs;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDock;
using System.Diagnostics;
using Infragistics.Win.UltraWinEditors;

namespace Sample
{
    public partial class Form1 : Form
    {
        private bool doubleClickFlagEnabled;
        private bool doubleClickFlag;

        public Form1()
        {
            InitializeComponent();
            this.doubleClickFlagEnabled = true;
            this.doubleClickFlag = true;
        }

        private void ultraDockManager1_BeforeToggleDockState(object sender, Infragistics.Win.UltraWinDock.CancelablePaneEventArgs e)
        {
            if (this.doubleClickFlagEnabled && this.doubleClickFlag)
            {
                e.Cancel = true;
            }
        }

        private void ultraDockManager1_MouseEnterElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is PaneCaptionTextAreaUIElement)
            {
                e.Element.Control.MouseDoubleClick += new MouseEventHandler(Control_MouseDoubleClick);
                e.Element.Control.MouseDown += new MouseEventHandler(Control_MouseDown);
            }
        }

        private void ultraDockManager1_MouseLeaveElement(object sender, Infragistics.Win.UIElementEventArgs e)
        {
            if (e.Element is PaneCaptionTextAreaUIElement)
            {
                e.Element.Control.MouseDoubleClick -= new MouseEventHandler(Control_MouseDoubleClick);
                e.Element.Control.MouseDown -= new MouseEventHandler(Control_MouseDown);
            }
        }

        private void Control_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                if (this.doubleClickFlagEnabled)
                {
                    this.doubleClickFlag = false;
                }
            }
        }

        private void Control_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (this.doubleClickFlagEnabled)
            {
                this.doubleClickFlag = true;
            }
        }

        private void ultraDockManager1_PropertyChanged(object sender, Infragistics.Win.PropertyChangedEventArgs e)
        {
            if (this.doubleClickFlagEnabled)
            {
                this.doubleClickFlag = true;
            }
        }

        private void ultraOptionSet1_ValueChanged(object sender, EventArgs e)
        {
            UltraOptionSet optionSet = sender as UltraOptionSet;
            if (optionSet.CheckedItem.DisplayText == "Enabled")
            {
                this.doubleClickFlagEnabled = false;
            }
            else
            {
                this.doubleClickFlagEnabled = true;
            }
        }
    }
}
